"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InterceptionProxyPageConfig = void 0;
const interfaces_1 = require("../interfaces");
const mixins_1 = require("../mixins");
const Request_1 = require("./Request");
let PageBase = class PageBase {
};
PageBase = __decorate([
    mixins_1.applyConfigurableMixin,
    mixins_1.applyLoggableMixin
], PageBase);
class InterceptionProxyPageConfig extends PageBase {
    constructor(page, __parent) {
        super();
        this.page = page;
        this.__parent = __parent;
    }
    static async proceedNewPage(page, __parent) {
        if (page[interfaces_1.INTERCEPTION_KEY_HOOK]) {
            throw new Error('Interception hook already registered.');
        }
        const interceptionConfig = new InterceptionProxyPageConfig(page, __parent);
        page[interfaces_1.INTERCEPTION_KEY_HOOK] = interceptionConfig;
        page.on('request', (originalRequest) => {
            Request_1.InterceptionProxyRequest.proceedNewRequest({
                page: interceptionConfig.page,
                __parent: interceptionConfig,
                originalRequest
            });
        });
        // sad, but puppeteer-extra will not wait our promise. So we are doing that in the end
        await page.setRequestInterception(true);
        return interceptionConfig;
    }
}
exports.InterceptionProxyPageConfig = InterceptionProxyPageConfig;
//# sourceMappingURL=Page.js.map