/// <reference types="node" />
import type Puppeteer from 'puppeteer';
import EventEmitter from 'events';
import { IConfigurableMixin, ILoggableMixin, INetworkMixin, IInterceptionProxyRequest, INewRequestInitialArgs, IRequestOptions, RequestStage, IAbortReason, IInterceptionProxyResponse, IResponseOptions, IResponseOverrides, RequestMode } from '../interfaces';
declare class RequestBase extends EventEmitter {
}
interface RequestBase extends IConfigurableMixin, ILoggableMixin, INetworkMixin, IRequestOptions {
}
/**
 * Plugin' request. The request have significant difference with Puppeteer' request.
 */
declare class InterceptionProxyRequest extends RequestBase implements IInterceptionProxyRequest {
    emit2(eventName: string, payload: any): void;
    readonly page: Puppeteer.Page;
    readonly originalRequest: Puppeteer.HTTPRequest;
    readonly requestOptions: IRequestOptions;
    protected __stage: RequestStage;
    protected __parent: import("../interfaces").IInterceptionProxyPage;
    protected __response?: IInterceptionProxyResponse;
    protected __isAdjusted: boolean;
    constructor(initial: INewRequestInitialArgs, requestOptions: IRequestOptions);
    static proceedNewRequest(initial: INewRequestInitialArgs): Promise<void>;
    get stage(): RequestStage;
    set stage(value: RequestStage);
    protected __requestOptionSetter<T extends keyof IRequestOptions>(key: T, value: IRequestOptions[T]): void;
    protected _getResponseInstance(responseOptions?: IResponseOptions): Promise<IInterceptionProxyResponse>;
    protected _setResponseInstance(response: IInterceptionProxyResponse, mode?: RequestMode): void;
    getRequest(): IInterceptionProxyRequest;
    setResponse(response: IResponseOverrides): Promise<IInterceptionProxyResponse>;
    getResponse({ requestMode }?: {
        requestMode?: RequestMode;
    }): Promise<IInterceptionProxyResponse>;
    abort(abortReason?: IAbortReason): Promise<IInterceptionProxyResponse>;
    continue(): Promise<void>;
}
export { InterceptionProxyRequest, };
