/// <reference types="node" />
import type Puppeteer from 'puppeteer';
import EventEmitter from 'events';
import { IConfigurableMixin, ILoggableMixin, INetworkMixin, RequestStage, IInterceptionProxyRequest, IInterceptionProxyResponse, IResponseOverrides, IAbortOverrides, IResponseOptions, IAbortReason } from '../interfaces';
declare class ResponseBase extends EventEmitter {
}
interface ResponseBase extends IConfigurableMixin, ILoggableMixin, INetworkMixin, Partial<IResponseOverrides>, Partial<IAbortOverrides> {
}
declare class InterceptionProxyResponse extends ResponseBase implements IInterceptionProxyResponse {
    originalResponse?: Puppeteer.HTTPResponse;
    emit2(eventName: string, payload: any): void;
    protected __parent: IInterceptionProxyRequest;
    responseOptions: IResponseOptions;
    constructor(__parent: IInterceptionProxyRequest, responseOptions: IResponseOptions);
    static __getResponse(request: IInterceptionProxyRequest): Promise<IResponseOptions>;
    static proceedNewResponse(request: IInterceptionProxyRequest, responseOptions?: IResponseOptions): Promise<IInterceptionProxyResponse>;
    static proceedOriginalResponse(request: IInterceptionProxyRequest, originalResponse: Puppeteer.HTTPResponse): Promise<IInterceptionProxyResponse>;
    getRequest(): IInterceptionProxyRequest;
    get page(): Puppeteer.Page;
    get originalRequest(): Puppeteer.HTTPRequest;
    get stage(): RequestStage;
    set stage(value: RequestStage);
    protected __responseOptionSetter<T extends keyof IResponseOverrides | 'abortReason'>(key: T, value: any): void;
    setResponse(responseOptions: IResponseOptions): Promise<IInterceptionProxyResponse>;
    getResponse(): Promise<IInterceptionProxyResponse>;
    abort(abortReason?: IAbortReason): Promise<IInterceptionProxyResponse>;
    continue(): Promise<void>;
}
export { InterceptionProxyResponse, };
