"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._OriginalRequestStateManager = void 0;
/**
 * keep in track frow state
 *
 * @internal
 */
class _OriginalRequestStateManager {
    constructor(page, request) {
        this.page = page;
        this.request = request;
        this.userListeners = [];
        this.pageListeners = {
            response: (response) => {
                if (response.request() !== request)
                    return;
                this.close(response);
            },
            requestfailed: (_request) => {
                if (_request !== request)
                    return;
                this.close();
            },
            requestfinished: (_request) => {
                if (_request !== request)
                    return;
                this.close();
            },
        };
        this.setListeners('on');
    }
    setListeners(method) {
        Object.entries(this.pageListeners).forEach(([name, listener]) => 
        // @ts-ignore: should we do typings?
        this.page[method](name, listener));
    }
    onResponse(listener) {
        if (this.response !== undefined) {
            listener(this.response);
            return;
        }
        this.userListeners.push(listener);
    }
    close(response) {
        if (this.response !== undefined)
            return;
        const resultResponse = this.response = response || this.request.response();
        this.setListeners('off');
        const userListeners = this.userListeners;
        this.userListeners = [];
        userListeners.forEach(listener => listener(resultResponse));
    }
}
exports._OriginalRequestStateManager = _OriginalRequestStateManager;
//# sourceMappingURL=_OriginalRequestStateManager.js.map