"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.dataUrlHandler = exports.dataUrlHandlerKey = void 0;
const data_urls_1 = __importDefault(require("data-urls"));
exports.dataUrlHandlerKey = 'dataUrl';
async function dataUrlHandler(request) {
    const { url } = request;
    if (!url.startsWith('data:'))
        return;
    const dataURL = (0, data_urls_1.default)(url);
    if (!dataURL)
        return; // the result cannot be parsed as a data: URL.
    const contentType = dataURL.mimeType.toString();
    return {
        status: 200,
        headers: {
            'content-type': contentType
        },
        // contentType,
        body: dataURL.body,
    };
}
exports.dataUrlHandler = dataUrlHandler;
//# sourceMappingURL=dataUrl.js.map