"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyLoggableMixin = void 0;
/**
 * @utyfua:
 * - I understand `.debug` exists for causes like this
 * but in my practice I should collect such information
 * and save in logs witch I can easily filter it after.
 */
function applyLoggableMixin(base) {
    class LoggableMixin extends base {
        recordError(message, error, ...meta) {
            this.logger({
                level: 'error',
                message,
                error,
                meta,
            });
        }
        recordInternalError(message, ...meta) {
            const error = new Error(message);
            this.recordError(message, error, ...meta);
        }
        recordWarning(message, ...meta) {
            this.logger({
                level: 'warning',
                message,
                meta,
            });
        }
    }
    return LoggableMixin;
}
exports.applyLoggableMixin = applyLoggableMixin;
//# sourceMappingURL=LoggableMixin.js.map