"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.adjustRequestCorsHeaders = void 0;
const urls_1 = require("./urls");
function getFrameUrl(frame) {
    if (!frame)
        return null;
    const url = frame.url();
    if (url)
        return url;
    const parentFrame = frame.parentFrame();
    return getFrameUrl(parentFrame);
}
function adjustRequestCorsHeaders({ originalRequest }, requestOptions) {
    const frame = originalRequest.frame();
    const frameUrl = getFrameUrl(frame);
    if (!frameUrl || originalRequest.resourceType() !== "xhr")
        return;
    try {
        if ((0, urls_1.getDomain)(frameUrl) === (0, urls_1.getDomain)(requestOptions.url))
            return;
        requestOptions.headers['Origin'] = (0, urls_1.getOrigin)(frameUrl);
    }
    catch (error) {
        console.error(error);
    }
}
exports.adjustRequestCorsHeaders = adjustRequestCorsHeaders;
//# sourceMappingURL=cors.js.map