"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getStageEnhancedErrorMessage = void 0;
const interfaces_1 = require("../interfaces");
function getStageEnhancedErrorMessage(key, stage) {
    let message = 'unknown stage??';
    switch (stage) {
        // case RequestStage.initial:
        //     message = 'the request was not initialized properly yet';
        //     break;
        case interfaces_1.RequestStage.gotRequest:
            message = 'the request was not initialized properly yet';
            break;
        case interfaces_1.RequestStage.sentRequest:
            message = 'the request started to getting the response';
            break;
        case interfaces_1.RequestStage.gotResponse:
            message = 'the request already got the response';
            break;
        case interfaces_1.RequestStage.sentResponse:
            message = 'response for this request already were send to puppeteer';
            break;
        case interfaces_1.RequestStage.closed:
            message = 'destination browser of page were already closed';
            break;
        default:
            message = 'the request currently in unknown stage';
            break;
    }
    return `Unable to enhance ${key} because ${message}`;
}
exports.getStageEnhancedErrorMessage = getStageEnhancedErrorMessage;
//# sourceMappingURL=errors.js.map