"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCDPSession = void 0;
function getCDPSession(page, request) {
    // WARNING: we are using private property of Puppeteer.HTTPRequest here
    // @ts-ignore: _client is private but we want to get this variable
    let client = request._client;
    // for puppeteer@13 and below
    if (client)
        return client;
    // in another case we deal with private property #client
    // get frame' client if possible
    const frame = request.frame();
    if (frame) {
        // @ts-ignore: its inaccessible in types for puppeteer@13 and below
        return frame._client();
    }
    // in another case just return page' client
    // @ts-ignore: its inaccessible in types for puppeteer@13 and below
    return page._client();
}
exports.getCDPSession = getCDPSession;
//# sourceMappingURL=getCDPSession.js.map